(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/core'), require('@angular/router'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-access', ['exports', 'rxjs', '@angular/core', '@angular/router', 'rxjs/operators'], factory) :
    (factory((global['ngx-access'] = {}),global.rxjs,global.ng.core,global.ng.router,global.rxjs.operators));
}(this, (function (exports,rxjs,i0,i1,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var ACCESS_CONFIG = new i0.InjectionToken('ACCESS_CONFIG');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m)
            return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length)
                    o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var /**
     * @abstract
     */ AccessStrategy = /** @class */ (function () {
        function AccessStrategy() {
        }
        return AccessStrategy;
    }());
    var FakeAccessStrategy = /** @class */ (function (_super) {
        __extends(FakeAccessStrategy, _super);
        function FakeAccessStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} access
         * @return {?}
         */
        FakeAccessStrategy.prototype.has = /**
         * @param {?} access
         * @return {?}
         */
            function (access) {
                return rxjs.of(false);
            };
        FakeAccessStrategy.decorators = [
            { type: i0.Injectable }
        ];
        return FakeAccessStrategy;
    }(AccessStrategy));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} config
     * @param {?=} __1
     * @return {?}
     */
    function flatten(config, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.parse, parse = _c === void 0 ? ( /**
         * @param {?} v
         * @return {?}
         */function (v) { return v; }) : _c, _d = _b.group, group = _d === void 0 ? false : _d;
        /** @type {?} */
        var flatConfig = {};
        /**
         * @param {?} path
         * @param {?} value
         * @return {?}
         */
        function setConfig(path, value) {
            if (!flatConfig[path]) {
                flatConfig[path] = new Set();
            }
            flatConfig[path].add(value);
        }
        /**
         * @param {?} path
         * @param {?} delimiter
         * @param {?} prop
         * @return {?}
         */
        function getPath(path, delimiter, prop) {
            return path
                ? path + delimiter + prop
                : prop;
        }
        /**
         * @param {?} accesses
         * @param {?} prop
         * @param {?} value
         * @param {?} path
         * @return {?}
         */
        function visitor(accesses, prop, value, path) {
            if (Array.isArray(value)) {
                value.forEach(( /**
                 * @param {?} access
                 * @return {?}
                 */function (access) {
                    visitor(accesses, prop, access, path);
                }));
            }
            else if (typeof value === 'object') {
                /** @type {?} */
                var childrenAccesses = children(value, getPath(path, '.', prop));
                if (group) {
                    accesses = accesses.concat(childrenAccesses);
                    accesses.forEach(( /**
                     * @param {?} access
                     * @return {?}
                     */function (access) {
                        setConfig(getPath(path, ':', access.prop), access.action);
                    }));
                }
            }
            else {
                /** @type {?} */
                var expression = parse(value.replace(/\s/g, ''));
                setConfig(getPath(path, ':', prop), expression);
                accesses = accesses.concat({ action: expression, prop: prop });
            }
            return accesses;
        }
        /**
         * @param {?} obj
         * @param {?=} path
         * @return {?}
         */
        function children(obj, path) {
            if (path === void 0) {
                path = '';
            }
            return Object.keys(obj)
                .reduce(( /**
         * @param {?} accesses
         * @param {?} prop
         * @return {?}
         */function (accesses, prop) { return visitor(accesses, prop, obj[prop], path); }), []);
        }
        children(config);
        return flatConfig;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TokenType = {
        PAR_OPEN: '('.charCodeAt(0),
        PAR_CLOSE: ')'.charCodeAt(0),
        OP_NOT: '!'.charCodeAt(0),
        BINARY_AND: '&'.charCodeAt(0),
        BINARY_OR: '|'.charCodeAt(0),
        LITERAL: 'LITERAL',
        END: 'END',
        LEAF: 'LEAF',
        ATOMIC: 'ATOMIC'
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var operator = ( /**
     * @param {?} evaluator$
     * @param {?} op
     * @return {?}
     */function (evaluator$, op) {
        return ( /**
         * @param {?} source
         * @return {?}
         */function (source) {
            return rxjs.Observable.create(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                /** @type {?} */
                var finish$ = new rxjs.Subject();
                /** @type {?} */
                var lastEval;
                finish$
                    .pipe(operators.take(1))
                    .subscribe(( /**
             * @param {?} value
             * @return {?}
             */function (value) {
                    observer.next(value);
                    observer.complete();
                }), ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) { return observer.error(e); }));
                source.
                    pipe(operators.switchMap(evaluator$), operators.takeUntil(finish$))
                    .subscribe(( /**
             * @param {?} value
             * @return {?}
             */function (value) {
                    lastEval = op === TokenType.OP_NOT ? !value : value;
                    if (op === TokenType.BINARY_AND && !lastEval) {
                        finish$.next(false);
                    }
                    else if (op === TokenType.BINARY_OR && lastEval) {
                        finish$.next(true);
                    }
                }), ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    finish$.error(e);
                }), ( /**
                 * @param {?} _
                 * @return {?}
                 */function (_) {
                    finish$.next(lastEval);
                }));
            }));
        });
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var Tokenizer = ( /**
     * @param {?} exp
     * @return {?}
     */function (exp) {
        var e_1, _a;
        /** @type {?} */
        var literal = '';
        /** @type {?} */
        var tokens = [];
        try {
            for (var exp_1 = __values(exp), exp_1_1 = exp_1.next(); !exp_1_1.done; exp_1_1 = exp_1.next()) {
                var char = exp_1_1.value;
                /** @type {?} */
                var code = char.charCodeAt(0);
                switch (code) {
                    case TokenType.PAR_OPEN:
                    case TokenType.PAR_CLOSE:
                    case TokenType.OP_NOT:
                    case TokenType.BINARY_AND:
                    case TokenType.BINARY_OR:
                        if (literal) {
                            tokens.push({
                                type: TokenType.LITERAL,
                                value: literal
                            });
                            literal = '';
                        }
                        tokens.push({
                            type: code,
                            value: char
                        });
                        break;
                    default:
                        literal += char;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (exp_1_1 && !exp_1_1.done && (_a = exp_1.return))
                    _a.call(exp_1);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        if (literal)
            tokens.push({
                type: TokenType.LITERAL,
                value: literal
            });
        return tokens;
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var PolishNotation = ( /**
     * @param {?} tokens
     * @return {?}
     */function (tokens) {
        /** @type {?} */
        var queue = [];
        /** @type {?} */
        var stack = [];
        /** @type {?} */
        var subQueue = [];
        /** @type {?} */
        var subStack = [];
        tokens.forEach(( /**
         * @param {?} token
         * @return {?}
         */function (token) {
            switch (token.type) {
                case TokenType.LITERAL:
                case TokenType.OP_NOT:
                    if (subStack.length) {
                        subQueue.push(token);
                    }
                    else {
                        queue.push(token);
                    }
                    break;
                case TokenType.BINARY_AND:
                case TokenType.BINARY_OR:
                    if (subStack.length) {
                        subStack.unshift(token);
                    }
                    else {
                        stack.unshift(token);
                    }
                    break;
                case TokenType.PAR_OPEN:
                    subStack.unshift(token);
                    break;
                case TokenType.PAR_CLOSE:
                    while (subStack.length &&
                        subStack[subStack.length - 1].type !== TokenType.PAR_OPEN) {
                        subQueue.unshift(subStack.pop());
                    }
                    subStack.pop();
                    if (subStack.length && subStack[subStack.length - 1].type === TokenType.OP_NOT) {
                        subQueue.unshift(subStack.pop());
                    }
                    queue = queue.concat(__spread(subStack, subQueue));
                    subStack = [];
                    subQueue = [];
                    break;
                default:
                    break;
            }
            // debugger;
        }));
        /** @type {?} */
        var result = (stack.length && __spread(stack, queue)) || queue;
        return result;
    });
    /** @type {?} */
    var PolishGenerator = ( /**
     * @param {?} polish
     * @return {?}
     */function (polish) {
        var index;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    index = 0;
                    _a.label = 1;
                case 1:
                    if (!(index < polish.length - 1))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, polish[index]];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    index++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, polish[polish.length - 1]];
            }
        });
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ExpNode = /** @class */ (function () {
        function ExpNode(op, left, right, literal) {
            this.op = op;
            this.left = left;
            this.right = right;
            this.literal = literal;
        }
        /**
         * @return {?}
         */
        ExpNode.prototype.isLeaf = /**
         * @return {?}
         */
            function () {
                return this.op === TokenType.LEAF;
            };
        /**
         * @return {?}
         */
        ExpNode.prototype.isAtomic = /**
         * @return {?}
         */
            function () {
                return (this.isLeaf() || (this.op === TokenType.OP_NOT && this.left.isLeaf()));
            };
        /**
         * @return {?}
         */
        ExpNode.prototype.getLiteralValue = /**
         * @return {?}
         */
            function () {
                return this.literal;
            };
        /**
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
        ExpNode.CreateAnd = /**
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
            function (left, right) {
                return new ExpNode(TokenType.BINARY_AND, left, right);
            };
        /**
         * @param {?} exp
         * @return {?}
         */
        ExpNode.CreateNot = /**
         * @param {?} exp
         * @return {?}
         */
            function (exp) {
                return new ExpNode(TokenType.OP_NOT, exp);
            };
        /**
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
        ExpNode.CreateOr = /**
         * @param {?} left
         * @param {?} right
         * @return {?}
         */
            function (left, right) {
                return new ExpNode(TokenType.BINARY_OR, left, right);
            };
        /**
         * @param {?} lit
         * @return {?}
         */
        ExpNode.CreateLiteral = /**
         * @param {?} lit
         * @return {?}
         */
            function (lit) {
                return new ExpNode(TokenType.LEAF, null, null, lit);
            };
        return ExpNode;
    }());
    /** @type {?} */
    var make = ( /**
     * @param {?} gen
     * @return {?}
     */function (gen) {
        /** @type {?} */
        var data = gen.next().value;
        switch (data.type) {
            case TokenType.LITERAL:
                return ExpNode.CreateLiteral(data.value);
            case TokenType.OP_NOT:
                return ExpNode.CreateNot(make(gen));
            case TokenType.BINARY_AND: {
                /** @type {?} */
                var left = make(gen);
                /** @type {?} */
                var right = make(gen);
                return ExpNode.CreateAnd(left, right);
            }
            case TokenType.BINARY_OR: {
                /** @type {?} */
                var left = make(gen);
                /** @type {?} */
                var right = make(gen);
                return ExpNode.CreateOr(left, right);
            }
        }
        return null;
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var parser = ( /**
     * @param {?} exp
     * @return {?}
     */function (exp) {
        /** @type {?} */
        var tokens = Tokenizer(exp.replace(/\s/g, ''));
        /** @type {?} */
        var polish = PolishNotation(tokens);
        /** @type {?} */
        var gen = PolishGenerator(polish);
        /** @type {?} */
        var tree = make(gen);
        return tree;
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var configurationAccess = {};
    /** @type {?} */
    var hasAccessStrategy = ( /**
     * @return {?}
     */function () { return rxjs.of(false); });
    /**
     * @param {?} config
     * @return {?}
     */
    function setConfigurationAccess(config) {
        configurationAccess = flatten(config, { parse: parser, group: true });
    }
    /**
     * @param {?} accessTest
     * @return {?}
     */
    function setHasAccessStrategy(accessTest) {
        hasAccessStrategy = accessTest;
    }
    /**
     * @param {?} expression
     * @return {?}
     */
    function parse(expression) {
        /** @type {?} */
        var arr = expression.replace(/\s/g, '').split(':');
        return {
            path: (arr[0] || ''),
            action: (arr[1] || '')
        };
    }
    /**
     * @param {?} accessExpression
     * @return {?}
     */
    function canAccessExpression(accessExpression) {
        return rxjs.of(accessExpression)
            .pipe(operators.map(( /**
     * @param {?} ae
     * @return {?}
     */function (ae) { return ae.replace(/\s/g, ''); })), operators.switchMap(( /**
         * @param {?} ae
         * @return {?}
         */function (ae) { return nodeEvaluator$1(parser(ae), hasAccessStrategy); })));
    }
    /**
     * @param {?} accessPath
     * @return {?}
     */
    function canAccessPaths(accessPath) {
        /** @type {?} */
        var access = Array.isArray(accessPath)
            ? accessPath
            : [accessPath];
        return rxjs.from(access)
            .pipe(operators.map(( /**
     * @param {?} ap
     * @return {?}
     */function (ap) { return ap.replace(/\s/g, ''); })), operator(( /**
         * @param {?} ap
         * @return {?}
         */function (ap) { return canAccessPath(ap); }), TokenType.BINARY_OR));
    }
    /**
     * @param {?} path
     * @return {?}
     */
    function canAccessPath(path) {
        try {
            /** @type {?} */
            var access = configurationAccess[path];
            if (!!access) {
                return rxjs.from(access)
                    .pipe(operator(( /**
             * @param {?} tree
             * @return {?}
             */function (tree) { return nodeEvaluator$1(tree, hasAccessStrategy); }), TokenType.BINARY_OR));
            }
            console.error("Undefined path " + path);
            return rxjs.of(false);
        }
        catch (e) {
            console.error(e);
            return rxjs.of(false);
        }
    }
    /**
     * @param {?} tree
     * @param {?} literalEvaluator
     * @return {?}
     */
    function nodeEvaluator$1(tree, literalEvaluator) {
        if (tree.isLeaf()) {
            console.log('Evaluating with ' + tree.getLiteralValue());
            return literalEvaluator(tree.getLiteralValue());
        }
        if (tree.op === TokenType.OP_NOT) {
            return rxjs.of(tree.left)
                .pipe(operator(( /**
         * @param {?} tree
         * @return {?}
         */function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }), TokenType.OP_NOT));
        }
        if (tree.op === TokenType.BINARY_OR) {
            return rxjs.from([tree.left, tree.right])
                .pipe(operator(( /**
         * @param {?} tree
         * @return {?}
         */function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }), TokenType.BINARY_OR));
        }
        if (tree.op === TokenType.BINARY_AND) {
            return rxjs.from([tree.left, tree.right])
                .pipe(operator(( /**
         * @param {?} tree
         * @return {?}
         */function (tree) { return nodeEvaluator$1(tree, literalEvaluator); }), TokenType.BINARY_AND));
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessService = /** @class */ (function () {
        function AccessService(config, accessStrategy) {
            setHasAccessStrategy(( /**
             * @param {?} accessName
             * @return {?}
             */function (accessName) { return accessStrategy.has(accessName); }));
            setConfigurationAccess(config.accesses || {});
        }
        /**
         * @param {?} accessPaths
         * @return {?}
         */
        AccessService.prototype.can = /**
         * @param {?} accessPaths
         * @return {?}
         */
            function (accessPaths) {
                return canAccessPaths(accessPaths);
            };
        /**
         * @param {?} accessExpression
         * @return {?}
         */
        AccessService.prototype.canExpression = /**
         * @param {?} accessExpression
         * @return {?}
         */
            function (accessExpression) {
                return canAccessExpression(accessExpression);
            };
        AccessService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AccessService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [ACCESS_CONFIG,] }] },
                { type: AccessStrategy }
            ];
        };
        /** @nocollapse */ AccessService.ngInjectableDef = i0.defineInjectable({ factory: function AccessService_Factory() { return new AccessService(i0.inject(ACCESS_CONFIG), i0.inject(AccessStrategy)); }, token: AccessService, providedIn: "root" });
        return AccessService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessDirective = /** @class */ (function () {
        function AccessDirective(template, viewContainer, accessService, parentAccessDirective) {
            this.template = template;
            this.viewContainer = viewContainer;
            this.accessService = accessService;
            this.parentAccessDirective = parentAccessDirective;
            this.onDestroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        AccessDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.template) {
                    /** @type {?} */
                    var ngxAccess = this.ngxAccess;
                    if (this.parentAccessDirective) {
                        var _a = parse(this.parentAccessDirective.ngxAccess), path_1 = _a.path, action = _a.action;
                        if (this.ngxAccess) {
                            if (Array.isArray(this.ngxAccess)) {
                                ngxAccess = this.ngxAccess.map(( /**
                                 * @param {?} access
                                 * @return {?}
                                 */function (access) { return access.replace('$', path_1); })) + ":" + action;
                            }
                            else {
                                var _b = parse(ngxAccess), childPath = _b.path, childAction = _b.action;
                                ngxAccess = childPath.replace('$', path_1) + ":" + (childAction ? childAction : action);
                            }
                        }
                        else {
                            ngxAccess = path_1 + ":" + action;
                        }
                    }
                    this.accessService.can(ngxAccess)
                        .pipe(operators.takeUntil(this.onDestroy$))
                        .subscribe(( /**
                 * @param {?} access
                 * @return {?}
                 */function (access) {
                        return access
                            ? _this.viewContainer.createEmbeddedView(_this.template)
                            : _this.ngxAccessElse
                                ? _this.viewContainer.createEmbeddedView(_this.ngxAccessElse)
                                : null;
                    }));
                }
            };
        /**
         * @return {?}
         */
        AccessDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.onDestroy$.next();
                this.onDestroy$.complete();
            };
        AccessDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[ngxAccess]'
                    },] }
        ];
        /** @nocollapse */
        AccessDirective.ctorParameters = function () {
            return [
                { type: i0.TemplateRef, decorators: [{ type: i0.Optional }] },
                { type: i0.ViewContainerRef },
                { type: AccessService },
                { type: AccessDirective, decorators: [{ type: i0.Optional }, { type: i0.SkipSelf }, { type: i0.Host }] }
            ];
        };
        AccessDirective.propDecorators = {
            ngxAccess: [{ type: i0.Input }],
            ngxAccessElse: [{ type: i0.Input }]
        };
        return AccessDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessExpressionDirective = /** @class */ (function () {
        function AccessExpressionDirective(template, viewContainer, accessService) {
            this.template = template;
            this.viewContainer = viewContainer;
            this.accessService = accessService;
            this.onDestroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        AccessExpressionDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.template) {
                    this.accessService.canExpression(this.ngxAccessExpr)
                        .pipe(operators.takeUntil(this.onDestroy$))
                        .subscribe(( /**
                 * @param {?} access
                 * @return {?}
                 */function (access) {
                        return access
                            ? _this.viewContainer.createEmbeddedView(_this.template)
                            : _this.ngxAccessExprElse
                                ? _this.viewContainer.createEmbeddedView(_this.ngxAccessExprElse)
                                : null;
                    }));
                }
            };
        /**
         * @return {?}
         */
        AccessExpressionDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.onDestroy$.next();
                this.onDestroy$.complete();
            };
        AccessExpressionDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[ngxAccessExpr]'
                    },] }
        ];
        /** @nocollapse */
        AccessExpressionDirective.ctorParameters = function () {
            return [
                { type: i0.TemplateRef },
                { type: i0.ViewContainerRef },
                { type: AccessService }
            ];
        };
        AccessExpressionDirective.propDecorators = {
            ngxAccessExpr: [{ type: i0.Input }],
            ngxAccessExprElse: [{ type: i0.Input }]
        };
        return AccessExpressionDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessGuard = /** @class */ (function () {
        function AccessGuard(router, accessService, config) {
            this.router = router;
            this.accessService = accessService;
            this.config = config;
        }
        /**
         * @param {?} next
         * @return {?}
         */
        AccessGuard.prototype.canActivate = /**
         * @param {?} next
         * @return {?}
         */
            function (next) {
                var _this = this;
                return this.accessService.can(next.data.accesses)
                    .pipe(operators.tap(( /**
             * @param {?} hasAccess
             * @return {?}
             */function (hasAccess) { return !hasAccess && _this.router.navigate([next.data.redirect || _this.config.redirect]); })));
            };
        AccessGuard.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AccessGuard.ctorParameters = function () {
            return [
                { type: i1.Router },
                { type: AccessService },
                { type: undefined, decorators: [{ type: i0.Inject, args: [ACCESS_CONFIG,] }] }
            ];
        };
        /** @nocollapse */ AccessGuard.ngInjectableDef = i0.defineInjectable({ factory: function AccessGuard_Factory() { return new AccessGuard(i0.inject(i1.Router), i0.inject(AccessService), i0.inject(ACCESS_CONFIG)); }, token: AccessGuard, providedIn: "root" });
        return AccessGuard;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccessModule = /** @class */ (function () {
        function AccessModule() {
        }
        /**
         * @param {?} config
         * @return {?}
         */
        AccessModule.forRoot = /**
         * @param {?} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: AccessModule,
                    providers: [
                        {
                            provide: ACCESS_CONFIG,
                            useValue: {
                                accesses: config.accesses || {},
                                redirect: config.redirect || '/unauthorized',
                            }
                        },
                        config.strategy || {
                            provide: AccessStrategy,
                            useClass: FakeAccessStrategy
                        }
                    ]
                };
            };
        AccessModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [AccessDirective, AccessExpressionDirective],
                        exports: [AccessDirective, AccessExpressionDirective]
                    },] }
        ];
        return AccessModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AccessModule = AccessModule;
    exports.AccessDirective = AccessDirective;
    exports.AccessExpressionDirective = AccessExpressionDirective;
    exports.setConfigurationAccess = setConfigurationAccess;
    exports.setHasAccessStrategy = setHasAccessStrategy;
    exports.parse = parse;
    exports.canAccessExpression = canAccessExpression;
    exports.canAccessPaths = canAccessPaths;
    exports.AccessGuard = AccessGuard;
    exports.AccessService = AccessService;
    exports.AccessStrategy = AccessStrategy;
    exports.FakeAccessStrategy = FakeAccessStrategy;
    exports.ACCESS_CONFIG = ACCESS_CONFIG;
    exports.ɵe = AccessExpressionDirective;
    exports.ɵa = AccessDirective;
    exports.ɵc = AccessStrategy;
    exports.ɵd = FakeAccessStrategy;
    exports.ɵb = AccessService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-access.umd.js.map